#! /usr/bin/env python
# coding=utf-8
'''
	Main window, main program.
	@author Alex Eftimie <alex(at)eftimie.ro>
	@date	17/10/2009
'''
import os, os.path
import gtk, pygtk, gtk.gdk
try:
	import gtk
	import gtk.glade
except:
	sys.exit(1)

class ThemeEditor:
	BACKGROUND = 'bg_800x600.jpg'
	LOGO = 'logo_small.png'
	NEWBACKGROUND = 'bg.jpg'
	NEWLOGO = 'logo.png'
	def __init__(self):
		homedir = os.path.expanduser('~')
		configdir = homedir + '/.xsplash-theme-editor'
		# creez dosar setari
		if not os.path.isdir(configdir):
			print "Creating home dir..."
			try:
				os.system('mkdir %s' % configdir)
			except(err):
				print "Error creating home dir"
				sys.exit(1)
		# copiez imaginile care ma intereseaza in home
		os.system('cp /usr/share/images/xsplash/* %s' % configdir)
		os.system('cp %s/%s %s/%s' % (configdir, 'bg_1280x1024.jpg', configdir, ThemeEditor.NEWBACKGROUND))
		os.system('cp %s/%s %s/%s' % (configdir, 'logo_xtra_large.png', configdir, ThemeEditor.NEWLOGO))
		# expun director
		self.configdir = configdir
		
class MainWindow:
	def __init__(self, te):
		self.te = te
		# initializez interfata din xml
		self.builder = gtk.Builder()
		self.builder.add_from_file('window.glade')
		self.window = self.builder.get_object('window1')
		self.builder.connect_signals(self)
		# incarc imagini la butoane
		self.set_buttons_images()
		self.window.show_all()
		
	def delete_event(self, event, data=None):
		gtk.main_quit()
		return False

	def about_dialog(event, data=None):
		ad = gtk.AboutDialog()
		ad.set_logo(ad.render_icon(gtk.STOCK_PREFERENCES, gtk.ICON_SIZE_DIALOG))
		ad.set_name("Xsplash Theme Editor")
		ad.set_authors(["Alex Eftimie <alex@eftimie.ro>"])
		ad.set_comments("for AJ")
		ad.set_version('0.1')
		ad.run()
		ad.destroy()
		
	def set_buttons_images(self):
		img1 = gtk.Image()
		pixbuf = gtk.gdk.pixbuf_new_from_file(self.te.configdir + '/' + ThemeEditor.BACKGROUND)
		scaled_buf = pixbuf.scale_simple(160, 120,gtk.gdk.INTERP_BILINEAR)
		img1.set_from_pixbuf(scaled_buf)
		b1 = self.builder.get_object('imgbutton1')
		b1.set_image(img1)
		img2 = gtk.Image()
		img2.set_from_file(self.te.configdir + '/' + ThemeEditor.LOGO)
		b2 = self.builder.get_object('imgbutton2')
		b2.set_image(img2)
	
	def launch_bg(self, event, data=None):
		self.launch_img(ThemeEditor.NEWBACKGROUND)
		
	def launch_logo(self, event, data=None):
		self.launch_img(ThemeEditor.NEWLOGO)

	def launch_img(self, care):
		os.system('gnome-open %s' % self.te.configdir + '/' + care)
	
	def create(self, care):
		but = self.builder.get_object('button1')
		lab = self.builder.get_object('label1')
		lab.set_label('Working...')
		but.set_sensitive(False)
		# aduc noile fisiere
		fc1 = self.builder.get_object('filechooserbutton1')
		if fc1.get_filename() != None:
			os.system('cp -T "%s" %s/%s' % (fc1.get_filename(), self.te.configdir, ThemeEditor.NEWBACKGROUND))
		fc2 = self.builder.get_object('filechooserbutton2')
		if fc2.get_filename() != None:
			os.system('cp -T "%s" %s/%s' % (fc2.get_filename(), self.te.configdir, ThemeEditor.NEWLOGO))
		# redimensionez
		os.system('./magic.sh %s %s background' % (self.te.configdir, ThemeEditor.NEWBACKGROUND))
		os.system('./magic.sh %s %s logo' % (self.te.configdir, ThemeEditor.NEWLOGO))
		# refac buton
		lab.set_label('Done')
		but.set_sensitive(True)
		self.set_buttons_images()
		
	def install(self, event, data=None):
		lab = self.builder.get_object('label1')
		lab.set_label('Working...')
		os.system('gksu --message "Please enter your password for copying the new files" cp %s/* /usr/share/images/xsplash/' % self.te.configdir)
		lab.set_label('Installed')
				
if __name__ == "__main__":
	ted = ThemeEditor()
	fer = MainWindow(ted);gtk.main()
